****************************************************************************
*                                                                          *
* AUTHOR:       R. Scott Mackay                                            *
*                                                                          *
* PROGRAM-ID:   Pop_Rec.PRG - February 1994                                *
*               Revised 05/23/94 - Allow numeric parameter for work area.  *
*                                                                          *
* DESCRIPTION:  When used after Push_Rec, allows you to return to the      *
*               previous record 'pushed' in the specified work area.       *
*               Results are retrieved from a public variable 'gcRecList'.  *
*                                                                          *
* SYNTAX:       Pop_Rec([<expC>])                                          *
* RETURNS:      Logical (was pop successfull?)                             *
* PARAMETERS:   expC - Alias to pop record in                              *
*                                                                          *
* EXAMPLE:      =Pop_Rec()         && Restore last 'pushed' record         *
* 	or          =Pop_Rec("States") && Restore last 'pushed' states record  *
*   or          =Pop_Rec(5)        && Resotre last 'pushed' record in 5    *
*                                                                          *
****************************************************************************
PARAMETERS lcAlias
PRIVATE lnObjLoc, lnObjLen, lcObject, lnOldRec

IF TYPE("m.gcRecList")='U'
	RETURN .F.																					&& Push w/o prior Pop
ENDIF

lcAlias = UPPER(IIF(PARAMETERS()=1,            ;
  IIF(TYPE("m.lcAlias")='N', ALIAS(m.lcAlias), ;
  UPPER(m.lcAlias)), ALIAS()))

***** GET LAST RECORD NUMBER *****
lnObjLoc = RAT(m.lcAlias, UPPER(m.gcRecList))
IF m.lnObjLoc=0
	RETURN .F.																					&& Push w/o prior Pop
ELSE
	lnObjLen = AT(',', SUBSTR(m.gcRecList, m.lnObjLoc))
	lcObject = SUBSTR(m.gcRecList, ;
		m.lnObjLoc, m.lnObjLen-1)
	lnOldRec = VAL(WORDNUM(m.lcObject, 2, '~'))
ENDIF

***** REMOVE RECORD SETTING FROM THE LIST *****
IF m.lnObjLoc+m.lnObjLen-1 = LEN(m.gcRecList)
	gcRecList = SUBSTR(m.gcRecList, 1, m.lnObjLoc-1)
ELSE
	gcRecList = SUBSTR(m.gcRecList, 1, m.lnObjLoc-1)+ ;
		SUBSTR(m.gcRecList, m.lnObjLoc+m.lnObjLen)
ENDIF

***** GO LAST RECORD *****
IF USED(m.lcAlias)
	IF ALIAS()==m.lcAlias
		=GoRec(m.lnOldRec)
	ELSE
		=Push_Sel(m.lcAlias)
		=GoRec(m.lnOldRec)
		=Pop_Sel()
	ENDIF
ELSE
	RETURN .F.																					&& Pop Failure
ENDIF

RETURN




********** GOREC **********
PROCEDURE GoRec
PARAMETERS RecNumber

IF BETWEEN(m.RecNumber, 1, RECCOUNT())
	GO m.RecNumber
	IF DELETED() AND SET("DELETED")=="ON"
		SKIP
	ENDIF
	IF EOF()
		GO BOTTOM
	ENDIF
ELSE
	GO BOTTOM
	IF !EOF()
		SKIP
	ENDIF
ENDIF
RETURN
