****************************************************************************
*                                                                          *
* AUTHOR:       R. Scott Mackay                                            *
*                                                                          *
* PROGRAM-ID:   Pop_Sel.PRG - February 1994                                *
*                                                                          *
* DESCRIPTION:  When used after Push_Sel, allows you to select the         *
*               previous alias or work area.  Results are retrieved from a *
*               public variable 'gcSelList'.                               *
*                                                                          *
* SYNTAX:       Pop_Sel()                                                  *
* RETURNS:      Logical (was pop successfull?)                             *
* PARAMETERS:   None                                                       *
*                                                                          *
* EXAMPLE:      =Pop_Sel()                                                 *
*                                                                          *
****************************************************************************
PRIVATE lcOldSel, lnOldArea, lcOldAlias

IF TYPE("m.gcSelList")='U'
	RETURN .F.																					&& Push w/o prior Pop
ENDIF

***** GET LAST WORK AREA / ALIAS *****
lcOldSel=WORDNUM(m.gcSelList, ;
	WORDS(m.gcSelList, ','), ',')
IF EMPTY(m.lcOldSel)
	RETURN .F.																					&& Push w/o prior Pop
ENDIF
lnOldArea  = WORDNUM(m.lcOldSel, 1, '~')
lcOldAlias = WORDNUM(m.lcOldSel, 2, '~')

***** SELECT LAST WORK AREA / ALIAS *****
IF USED(m.lcOldAlias)
	SELECT (m.lcOldAlias)
ELSE
	SELECT (VAL(m.lnOldArea))
ENDIF

***** REMOVE SELECT SETTING FROM THE LIST *****
gcSelList = LEFT(m.gcSelList, ;
	LEN(m.gcSelList)-LEN(m.lcOldSel)-1)

RETURN
