****************************************************************************
*                                                                          *
* AUTHOR:       R. Scott Mackay                                            *
*                                                                          *
* PROGRAM-ID:   Push_Ord.PRG - February 1994                               *
*               Revised 05/23/94 - Change parameters so that the 1st       *
*               parameter was always the index tag to avoid confusion.     *
*                                                                          *
* DESCRIPTION:  Allows you to change index order, and save the previous    *
*               index order.  When you want to restore the previous index  *
*               order, just use Pop_Ord.  Results are stored in a public   *
*               variable 'gcOrdList'.                                      *
*                                                                          *
* SYNTAX:       Push_Ord([<expC1>][, <expC2>])                             *
* RETURNS:      Void                                                       *
* PARAMETERS:   exp1 - Index Order Tag                                     *
*               exp2 - Index Order Alias                                   *
*                                                                          *
* EXAMPLE:      =Push_Ord()              && Save order only                *
*   or          =Push_Ord("Buyer")       && Set order to Buyer             *
* 	or          =Push_Ord("Buyer", "T1") && Set order to Buyer in 'T1'     *
* 	or          =Push_Ord("Buyer", 5)    && Set order to Buyer in area 5   *
*   or          =Push_Ord(5, 5)          && Set order to tag 5 in area 5   *
*                                                                          *
****************************************************************************
PARAMETERS lOrder, lcSelect
PRIVATE PCount, lcOldOrder

IF TYPE("gcOrdList")='U'
	PUBLIC gcOrdList
	gcOrdList=""
ENDIF

***** IDENTIFY PARAMETERS *****
PCount=PARAMETERS()
IF m.PCount<2
  lcSelect = ALIAS()
ELSE
	IF TYPE("m.lcSelect")='N'
		lcSelect = ALIAS(m.lcSelect)
	ENDIF
ENDIF
lcSelect   = UPPER(m.lcSelect)
lcOldOrder = IIF(EMPTY(m.lcSelect), "", ORDER(m.lcSelect))

***** PUSH OLD ORDER *****
gcOrdList = m.gcOrdList+'|'+m.lcSelect+'~'+m.lcOldOrder+','

***** SET NEW ORDER *****
IF TYPE("m.lOrder")#'L' AND USED(m.lcSelect)
	IF ALIAS()==m.lcSelect
		SET ORDER TO (m.lOrder)
	ELSE
		SET ORDER TO (m.lORder) IN (m.lcSelect)
	ENDIF
ENDIF

RETURN
