****************************************************************************
*                                                                          *
* AUTHOR:       R. Scott Mackay                                            *
*                                                                          *
* PROGRAM-ID:   Push_Rec.PRG - February 1994                               *
*               Revised 05/23/94 - Change parameters so that the 1st       *
*               parameter was always the record# to avoid confusion.       *
*                                                                          *
* DESCRIPTION:  Allows you to 'GO' to a record, and save the previous      *
*               record number.  When you want to return to the previous    *
*               record, just use Pop_Rec.  Results are stored in a public  *
*               variable 'gcRecList'.                                      *
*                                                                          *
* SYNTAX:       Push_Rec([<expC>][, <expN>])                               *
* RETURNS:      Void                                                       *
* PARAMETERS:   expN - New record number                                   *
*               expr - Alias                                               *
*                                                                          *
* EXAMPLE:      =Push_Rec()              && Save record# only              *
*   or          =Push_Rec(25)            && Go record 25                   *
* 	or          =Push_Rec(10, "States")  && Go record 10 in 'States'       *
* 	or          =Push_Rec(30, 5)         && Go record 30 in work area 5    *
*                                                                          *
****************************************************************************
PARAMETERS lnRec, lcAlias
PRIVATE PCount, lnOldRec

IF TYPE("gcRecList")='U'
	PUBLIC gcRecList
	gcRecList=""
ENDIF

***** IDENTIFY PARAMETERS *****
PCount=PARAMETERS()
DO CASE
CASE m.PCount = 0
	lnRec   = 0
	lcAlias = ALIAS()
CASE m.PCount = 1
	lcAlias = ALIAS()
OTHERWISE
	IF TYPE("m.lcAlias")='N'
		lcAlias = ALIAS(m.lcAlias)
	ENDIF
ENDCASE
lcAlias  = UPPER(m.lcAlias)
lnOldRec = IIF(EMPTY(m.lcAlias), 0, RECNO(m.lcAlias))

***** PUSH OLD RECORD NUMBER *****
gcRecList = m.gcRecList+m.lcAlias+'~'+ ;
	ALLTRIM(STR(m.lnOldRec))+','

***** GO TO NEW RECORD *****
IF !EMPTY(m.lnRec) AND !EMPTY(m.lcAlias)
	IF ALIAS()==m.lcAlias
		=GoRec(m.lnRec)
	ELSE
		=Push_Sel(m.lcAlias)
		=GoRec(m.lnRec)
		=Pop_Sel()
	ENDIF
ENDIF

RETURN




********** GOREC **********
PROCEDURE GoRec
PARAMETERS RecNumber

IF BETWEEN(m.RecNumber, 1, RECCOUNT())
	GO m.RecNumber
	IF DELETED() AND SET("DELETED")=="ON"
		SKIP
	ENDIF
	IF EOF()
		GO BOTTOM
	ENDIF
ELSE
	GO BOTTOM
	IF !EOF()
		SKIP
	ENDIF
ENDIF
RETURN
