****************************************************************************
*                                                                          *
* AUTHOR:       R. Scott Mackay                                            *
*                                                                          *
* PROGRAM-ID:   Push_Sel.PRG - February 1994                               *
*                                                                          *
* DESCRIPTION:  Allows you to select a new work area or alias, and save    *
*               the previous work area.  When you want to restore the      *
*               previous work area, just use Pop_Sel.  Results are stored  *
*               in a public variable 'gcSelList'.                          *
*                                                                          *
* SYNTAX:       Push_Sel([<expN>|<expC>])                                  *
* RETURNS:      Void                                                       *
* PARAMETERS:   expN - Work Area                                           *
*               expC - Alias                                               *
*                                                                          *
* EXAMPLE:      =Push_Sel()          && Save work area only                *
*   or          =Push_Sel("States")  && Select States table                *
*   or          =Push_Sel(5)         && Select work area 5                 *
*                                                                          *
****************************************************************************
PARAMETERS lSelect
PRIVATE lnOldArea, lcOldAlis

IF TYPE("gcSelList")='U'
	PUBLIC gcSelList
	gcSelList=""
ENDIF

***** PUSH OLD WORK AREA / ALIAS *****
lnOldArea  = SELECT(0)
lcOldAlias = ALIAS()
gcSelList  = m.gcSelList+IIF(EMPTY(m.gcSelList), ;
	"", ',')+ALLTRIM(STR(m.lnOldArea,3))+'~'+m.lcOldAlias

***** SELECT NEW WORK AREA / ALIAS *****
IF !EMPTY(m.lSelect)
	SELECT (m.lSelect)
ENDIF

RETURN
